EnableExplicit

#Radius = 70

Define.i tempTexture, tempTexture2, tempMaterial, tempMaterial2, tempMesh, tempMesh2, camera, light, entity, entity2
Define.f x, z, degree

; init
InitEngine3D(#PB_Engine3D_DebugLog)
InitSprite()
InitKeyboard()
InitMouse()

OpenWindow(0,0,0,1024,768,"Normalmap",#PB_Window_SystemMenu|#PB_Window_ScreenCentered)
OpenWindowedScreen(WindowID(0), 0, 0, WindowWidth(0), WindowHeight(0), 0, 0, 0, #PB_Screen_WaitSynchronization)

WorldShadows(#PB_Shadow_Modulative)

Add3DArchive(".", #PB_3DArchive_FileSystem)
Parse3DScripts()

; create objects

tempTexture = CreateTexture(#PB_Any, 64, 64)
StartDrawing(TextureOutput(tempTexture))
Box(0, 0, 64, 64, RGB(128, 128, 128))
Box(0, 31, 64, 3, RGB(255, 255, 255))
Box(31, 0, 3, 64, RGB(255, 255, 255))
StopDrawing()
tempTexture2 = CreateTexture(#PB_Any, 1, 1)
StartDrawing(TextureOutput(tempTexture2))
Plot(0, 0, RGB(255, 0, 255))
StopDrawing()

tempMaterial  = GetScriptMaterial(#PB_Any, "metal")
tempMaterial2 = GetScriptMaterial(#PB_Any, "wood")

tempMesh     = CreateCube(#PB_Any, 50)
tempMesh2    = CreateCube(#PB_Any, 25)

entity = CreateEntity(#PB_Any, MeshID(tempMesh), MaterialID(tempMaterial), 0, 0, 0)
RotateEntity(entity, 0, 45, 0, #PB_Relative)

entity2 = CreateEntity(#PB_Any, MeshID(tempMesh2), MaterialID(tempMaterial2))
RotateEntity(entity2, 45, 45, 0, #PB_Absolute)

; create light
light = CreateLight(#PB_Any, RGB(225, 225, 225), 0, 0, 150, #PB_Light_Directional)
SetLightColor(light, #PB_Light_SpecularColor, RGB(255, 255, 255))
LightDirection(light, 0, 0, -1)

; create camera
camera = CreateCamera(#PB_Any, 0, 0, 100, 100)
MoveCamera(camera, 0, 0, 150, #PB_Absolute)

AmbientColor(RGB(16, 16, 16))

FreeMesh(tempMesh)
FreeMesh(tempMesh2)
FreeMaterial(tempMaterial)
FreeMaterial(tempMaterial2)
FreeTexture(tempTexture)
FreeTexture(tempTexture2)

Repeat
 
  While WindowEvent() : Wend
 
  If ExamineKeyboard()
    
  EndIf
  
  RotateEntity(entity, 0, 0.1, 0, #PB_Relative)
  
  Degree + 0.5
  
  If degree > 360
    degree - 360
  EndIf
      
  x = #Radius * Cos(Radian(degree))
  z = #Radius * Sin(Radian(degree))
  
  MoveEntity(entity2, x, 0, z, #PB_Absolute)
  
  RenderWorld()
  
  FlipBuffers()
 
Until KeyboardReleased(#PB_Key_Escape)

End

; IDE Options = PureBasic 5.20 LTS (Windows - x86)
; CursorPosition = 48
; FirstLine = 26
; CompileSourceDirectory
; Compiler = PureBasic 5.20 LTS (Windows - x86)
; EnablePurifier
; EnableCompileCount = 186
; EnableBuildCount = 0
; EnableExeConstant