sampler normalTexture: register(s0);
sampler specularTexture: register(s1);

uniform float4   lightPosition;
uniform float4   diffuse;
uniform float4   specular;
uniform float    shininess;
uniform float4   lightDiffuse;
uniform float4x4 view;

float4 main(	float4 texCoord:  TEXCOORD0,
		float3 pos:       TEXCOORD1,
		float3 lightDir:  TEXCOORD2,
		float3 halfAngle: TEXCOORD3
		) : COLOR0
{
    float4 result;
    
    float3 normalFromTexture = normalize((tex2D(normalTexture, texCoord).xyz - float3(0.5f, 0.5f, 0.5f)));
    float4 lightFactors = lit(dot(lightDir, normalFromTexture), dot(halfAngle, normalFromTexture), shininess);
    
    result = lightDiffuse * diffuse * lightFactors.y + specular * tex2D(specularTexture, texCoord) * lightFactors.z;

    return result;
}